 /**
  * OrdinatoreNumerico
  *
  * @author Adriano Luchetta
  * @version 11-Nov-2006
  * @version 5-Nov-2005
  * @version 20-Nov-2004
  *
  * <b> uso: java OrdinatoreNumerico <i> n nomeFile. </i></b><br>
  *
  * 1. Genera n numeri casuali fra 1 e n, dove <i>n</i> e' passato come argomento
  * sulla riga di comandi, memorizzandoli in un ArrayOrdinato.<br>
  * 2. Calcola la media dei valori dell'ArrayOrdinato.<br>
  * 3. Esegue un ciclo<br>
  *    - acquisizione di un numero i fra 1 e n compresi<br>
  *    - ricerca del numero i nell'ArrayOrdinato<br>
  *    - messaggio su standard output <br>
  *       "i: non e' presente"<br>
  *       "i: indice j"<br>
  * 4. Scrittura in ordine decrescente dei valori dell'ArrayOrdinato
  * a standard output, 10 numeri per riga.<br>
  */

import java.util.Scanner;
import java.util.Random;

public class OrdinatoreNumerico
{
   public static void main(String[] args)
   {
      final int NUMERI_PER_RIGA = 10;

      // gestione argomenti da riga di comando
      if (args.length < 1)
      {
         System.out.println("uso: $java OrdinatoreNumerico <dimensione>");
         return;
      }

      int n = Integer.parseInt(args[0]);
      if (n < 1)
      {
         System.out.println("uso: $java OrdinatoreNumerico <dimensione>, dimensione > 0");
         return;
      }

      // creazione array, generazione e inserimento nell'array dei numeri casuali
      ArrayOrdinato a = new ArrayOrdinato();
      Random rand = new Random();
      for (int i = 0; i < n; i++)
      {
         int k = (int)( 1 + (1 + n - 1)* rand.nextDouble());
         a.aggiungi(k);
      }

      // stampa della media
      System.out.println("media: " + a.media());

      // ciclo per ricerca numeri
      Scanner in = new Scanner(System.in);

      System.out.print("i?: ");
      while (in.hasNextInt())
      {
         int i = in.nextInt();
         int j = a.trova(i);
         if (j < 0)
            System.out.println(i + ": non presente");
         else
            System.out.println(i + ": indice " + j);
         
         System.out.print("i?: ");
      }

      // invio dei numeri in ordine decrescente a standard output
      int largColonna = args[0].length() + 1;
      int count = 1;
      while (!a.vuoto())
      {
         String str = Integer.toString(a.togliMax());
         while (str.length() < largColonna)
            str = " " + str;
         if ((count % NUMERI_PER_RIGA) == 0)
            str = str + "\n";
         System.out.print(str);

         count++;
      }
   }
}
